'
' ConnectServer - attach a server from within WFW
'	This does not run either the system login script or user login script
'
' Inputs:
'	ServerName - the name of the file server you wish to attach to
'	UserName - the name of the user account on the file server
'	Password - the user account's password
'
' Output:
'	Integer - result code (SUCCESSFUL if it works)
'
' DLL files required (with version numbers that work)
'	NWNETAPI.DLL 1.30
'	NWIPXSPX.DLL 4.00
'	
' NIVB files required (add them to your .MAK file):
'	NWBIND.BAS
'	NWCONN.BAS
'	NWDIAG.BAS
'	NWERROR.BAS
'	NWWRKSTN.BAS
'

Function ConnectServer (ServerName As String, UserName As String, Password As String) As Integer
    Dim Connection As Integer, CallResult As Integer

    CallResult = GetConnectionID(ServerName, Connection)
    If CallResult <> SUCCESSFUL Then
	' Error handling code
	ConnectServer = CallResult
	Exit Function
    End If
    SetPreferredConnectionID (Connection)
    CallResult = LoginToFileServer(UserName, OT_USER, Password)
    If CallResult <> SUCCESSFUL Then
	' Error handling code
    End If
    ConnectServer = CallResult
End Function
