# Makefile
# Copyright (c) 1992 Microsoft Corporation. All rights reserved.

# This line allows NMAKE to work as well MAKE
all: dlgapp.EXE

# Defines
APP_name = dlgapp
OBJS = $(APP_name).obj init.obj mainwnd.obj about.obj
APP_LIBS = libw slibcew dlldlg

!IFNDEF NONDEBUG
# Default to Debugging build
APP_compile = -c -W3 -AS -Gsw -Zipe -Od -D_WINDOWS
APP_link = /NOD /NOE /CO
MAPSYM = mapsym $(APP_name)
!ELSE
# Non-Debugging build
APP_compile = -c -W3 -AS -Gsw -Zpe -Os -D_WINDOWS
APP_link = /NOD /NOE
MAPSYM = 
!ENDIF


# Rules

# Update the object files if necessary
# Compile
.c.obj:
    cl $(APP_compile) $*.c

$(APP_name).obj: $(APP_name).c  $(APP_name).h  init.h  global.h

mainwnd.obj: mainwnd.c  mainwnd.h  about.h  global.h

init.obj: init.c  init.h  mainwnd.h  global.h

about.obj: about.c  about.h

# Update the resource if necessary
$(APP_name).res : $*.rc  $(APP_name).ico  global.h
    rc -r $*.rc

# Update the executable file if necessary, and if so, add the resource back in
$(APP_name).exe :: $(OBJS) $(APP_name).def $(APP_name).res dlldlg.lib
   link $(APP_link) $(OBJS),,,$(APP_LIBS), $(APP_name).def
   rc $*.res

