'used to read/write from own ini file
Declare Function GetPrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer, ByVal lpFileName As String) As Integer
'** Constants used to size buffers in win.ini call
  Const Max_SectionBuffer = 4096
  Const Max_EntryBuffer = 255
'get windows ini
Declare Function kpGetProfileString Lib "Kernel" Alias "GetProfileString" (ByVal lpAppName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer) As Integer

'only one write procedure for both strings and ints
Declare Function WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpstring As String, ByVal lplFileName As String) As Integer

Declare Function GetFreeSpace& Lib "Kernel" (ByVal wFlags%)
Global Const SWP_NOMOVE = 2
Global Const SWP_NOSIZE = 1
'used for on-top
Declare Function SetWindowPos Lib "user" (ByVal h%, ByVal hb%, ByVal x%, ByVal y%, ByVal cx%, ByVal cy%, ByVal f%) As Integer
'set top
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2

Type inputmask
    typeinchosen As Integer
    length As Integer
    decs As Integer
    min As Double
    max As Double
    bwzero As Integer
    relposinpx As Single
    relposinpy As Single
    DisplayOnly As Integer
    mandatory As Integer
    hstrlen As Integer
    helptext As String
    pstrlen As Integer
    prompttext As String
    udf1strlen As Integer
    udf1 As String
    udf2strlen As Integer
    udf2 As String
    udf3strlen As Integer
    udf3 As String
    udf4strlen As Integer
    udf4 As String
    udf5strlen As Integer
    udf5 As String
    tvstrlen As Integer
    toggleval As String
End Type
Global thismask As inputmask

'for help,min,max etc
Global detailsdbfilename$
Global inifilename$
'read in/set from win.ini in initialise
Global thedatesep$, monthfirstindates%, thedatesepasascii%
Global thedecimalcharasascii%

Sub about ()
    Rem display a message
    msg$ = "FDES, by BMC Programs Ltd"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "School Gardens"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "Shrewsbury, SY1 2AJ"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "United Kingdom"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "Tel (UK) (0)743-248515"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "FAX (UK) (0)743-236214"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "Version 001, 20th July 1994"
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + "@ BMC Programs Ltd."
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + Chr$(13) + Chr$(10)
    msg$ = msg$ + Str$(Int(GetFreeSpace&(0) / 1024)) + " KB free"
    MsgBox msg$, 64, "About this program"

End Sub

Sub basicdatecheck (bderr%, thisinput$, mask As inputmask)
On Error GoTo bdaterror
'check days in month, and months 1-12
'called from filterinput at the end if total length
'of the string now of required length
'ie before user tabs away
'will return basic error after posting message
 bderr% = False
 '1st check length is correct
 length% = Len(thisinput$)

If length% = 0 Then
   Exit Sub 'no point in doing a check!
End If


 Select Case mask.typeinchosen%
          
   Case 6 'ddmmyy
     If length% <> 6 Then
      length% = 6
      GoSub message
      bderr% = True
      Exit Sub
     End If

   Case 7 'dd/mm/yy
     If length% <> 8 Then
      length% = 8
      GoSub message
      bderr% = True
      Exit Sub
     End If
     'not needed since filterinput should tak out any incorrect keys
     'If Mid$(thisinput$, 3, 1) <> thedatesep$ Or Mid$(thisinput$, 6, 1) <> thedatesep$ Then
      ' MsgBox "Please enter "+thedatesep$+" after dd and after mm", 16, "Date Input Warning"
       'bderr% = True
       'Exit Sub
     'End If

   Case 8 'dd/mm/CCyy
     If length% <> 10 Then
      length% = 10
      GoSub message
      bderr% = True
      Exit Sub
     End If
     'not needed since filterinput should tak out any incorrect keys
     'If Mid$(thisinput$, 3, 1) <> thedatesep$ Or Mid$(thisinput$, 6, 1) <> thedatesep$ Then
      ' MsgBox "Please enter "+thedatesep$+" after dd and after mm", 16, "Date Input Warning"
       'bderr% = True
       'Exit Sub
     'End If
     
   
   Case Else
 
 End Select
 
        Select Case mask.typeinchosen%
          
          Case 6 'ddmmyy or mmddyy
            If monthfirstindates% Then
               d% = Val(Mid$(thisinput$, 3, 2))
               m% = Val(Left$(thisinput$, 2))
            Else
               m% = Val(Mid$(thisinput$, 3, 2))
               d% = Val(Left$(thisinput$, 2))
            End If
             
             GoSub day0131only
             If bderr% Then
                Exit Sub
             End If
              
             

             GoSub m0112only
             If bderr% Then
                Exit Sub
             End If
            
            GoSub daysinmonth
             If bderr% Then
                Exit Sub
             End If
            'DO NOT CARE ABOUT THE YEAR!
          
          
          Case 7, 8'dd/mm/yy OR dd/mm/CCyy
            If monthfirstindates% Then
               d% = Val(Mid$(thisinput$, 4, 2))
               m% = Val(Left$(thisinput$, 2))
            Else
               m% = Val(Mid$(thisinput$, 4, 2))
               d% = Val(Left$(thisinput$, 2))
            End If
             
             
             GoSub day0131only
             If bderr% Then
                Exit Sub
             End If
          
             
             GoSub m0112only
             If bderr% Then
                Exit Sub
             End If
            
            GoSub daysinmonth
             If bderr% Then
                Exit Sub
             End If
            'DO NOT CARE ABOUT THE YEAR!

          Case Else
          
        End Select

Exit Sub

'simple subs
'******************************************
day0131only:
 
  If d% > 31 Or d% < 1 Then
      MsgBox "Enter dd as 01 to 31 only", 16, "Date Input Warning"
      bderr% = True
  End If
Return
'******************************************
m0112only:
   If m% > 12 Or m% < 1 Then
        MsgBox "Month must have value 01 to 12", 16, "Date Input Warning"
        bderr% = True
   End If
Return
'******************************************
daysinmonth:
 
 If (m% = 9 Or m% = 4 Or m% = 6 Or m% = 11) And d% > 30 Then
       MsgBox "Max 30 days in the month", 16, "Date Input Warning"
       bderr% = True
       Return
 End If
           
 If m% = 2 And d% > 28 Then
       MsgBox "Max 28 days in the month (If leap year, enter 2902 as 2802)", 16, "Date Input Warning"
       bderr% = True
 End If

Return
'******************************************
message:
 MsgBox "Date must be" + Str$(length%) + " long", 16, "Date Input Warning"
Return
'******************************************


bdaterror:
If Err <> 13 Then
  Exit Sub
Else
  'type mismatch so doesn't recognise the date as valid
  Resume bdateerroro
End If

bdateerroro:
  MsgBox "Not a valid date format!", 16, "Date Input Warning"
Exit Sub

End Sub

Sub filterinput (keyascii As Integer, mask As inputmask)
 If keyascii = 8 Or keyascii = 13 Then 'backspace delete & Ret is passed, del isn't
  Exit Sub
 End If
'this is called from all keypress events for input controls only
'keyascii is global and is ascii char of key pressed
'final length is checked in finalfilter, called from lost focus
'NB remember that here screen.ActiveControl.text not yet updated with new keypress
y% = Len(Screen.ActiveControl.Text)


'Also get rid of any blanks at the start
Screen.ActiveControl.Text = LTrim$(Screen.ActiveControl.Text)

If y% = mask.length% And mask.length% > 0 Then
 Beep
 keyascii = 0
 MsgBox "Max length is" + Str$(mask.length%) + " characters", 16, "Input Warning"
 Exit Sub
End If

curspos% = Screen.ActiveControl.SelStart
'code below will ignore overwrite since standard text boxes ignore it
'insstate% = KeyStat1(1).Value

Select Case mask.typeinchosen%
   Case 1   'any char with auto upper case conversion
         'screen.ActiveControl.text = UCase$(screen.ActiveControl.text)
         If keyascii > 96 And keyascii < 123 Then
           keyascii = keyascii - 32
         End If
   Case 2 'any char with NO auto upper case conversion
         'do nothing!
   Case 3 'auto convert 1st letter to ucase for name
        If curspos% = 0 Then
            If keyascii < 65 And keyascii > 122 Then
              MsgBox "Must start with a letter!", 48
              keyascii = 0
              Exit Sub
            End If
            If keyascii > 96 And keyascii < 123 Then
               keyascii = keyascii - 32
            End If
        Else
            If Right$(Screen.ActiveControl.Text, 1) = Chr$(32) And convertpos% <> curspos% Then
                      'next char should be upper case if a letter and user has not overridden
               If keyascii > 96 And keyascii < 123 Then
                  keyascii = keyascii - 32
              'store position converted at. User may alter later
                  convertpos% = curspos%
               End If
            End If

        End If

    Case 4 'YN only. NB This check not one for list boxes since no user control
             'anyway on a list box!
         'insert or overtype makes no difference
         'since always test curpos%=1
         If keyascii <> 89 And keyascii <> 78 And keyascii <> 121 And keyascii <> 110 Then
           keyascii = 0
           MsgBox "Y or y or N or n only!", 16, "Input Warning"
         End If

   Case 5 'Numeric inc decs
        '      dec char (46 for .)             minus
        If keyascii = thedecimalcharasascii% Or keyascii = 45 Then
         'carry on
        Else

         GoSub numberonly
         If fierr% Then
           Exit Sub
         End If
        End If
         'number or dec point pressed!
         If keyascii = thedecimalcharasascii% And mask.decs = 0 Then
           keyascii = 0
           MsgBox "No decimals allowed!", 16, "Input Warning"
           Exit Sub
         End If
         'where is dec point? (remember text not yet updated!)
         z% = InStr(Screen.ActiveControl.Text, Chr$(thedecimalcharasascii%))
         decerr% = False
        'where is cursor in the box (starts at 0)
         If z% > 0 And (curspos% + 1) > z% And y% - z% = mask.decs Then
          'trying to input decs!
          decerr% = True
         End If
         
         

         'warning if applicable
         If decerr% = True Then
           MsgBox "Only" + Str$(mask.decs) + " decimals allowed!", 16, "Input Warning"
           keyascii = 0
           Exit Sub
         End If
       
   Case 6  'Day as ddmmyy
        GoSub numberonly
        If fierr% Then
           Exit Sub
        End If
        
   
   Case 7, 8'Date as dd/mm/yy or as dd/mm/ccyy
        If keyascii = thedatesepasascii% Then
         'carry on, it's the date separator (/ for US/UK but . for germany etc)
        Else
         GoSub numberonly
         If fierr% Then
           Exit Sub
         End If
        End If
        'add the / in as auto
        'need to add the keystroke and then put chr(thedatesepasascii%) (47 or / for US,UK) into keyascii
        If (y% = 1 Or y% = 4) And keyascii <> thedatesepasascii% Then
            'sel starts at 0
            
            Screen.ActiveControl.Text = Screen.ActiveControl.Text + Chr$(keyascii)
            keyascii = thedatesepasascii%
            Screen.ActiveControl.SelStart = y% + 1
        End If
   
   Case 9  '?
        'put your own code in here if yoy have added a flag=9!
   Case 10 '?
        'put your own code in here!
   Case 11  '?
         'put your own code in here!
   Case Else

End Select


Exit Sub

'******************************************
numberonly:
  fierr% = 0
  If keyascii < 48 Or keyascii > 57 Then
     MsgBox "Enter numbers 0 to 9 only", 16, "Input Warning"
     keyascii = 0
     fierr% = -1
  End If
Return
'******************************************

End Sub

Sub inierrmessage ()
errmessage:
    MsgBox "Error reading FDES bin file names in ini file", 16, "Fatal Error"
    'Call Exitmen
    Exit Sub

End Sub

Sub initialiseprogram ()
On Error GoTo initerror
drivereq$ = Left$(App.Path, 2)
ChDrive drivereq$
ChDir App.Path
inifilename$ = App.Path + "\sample.ini"

Load Helpdis1

'default is returned if param$ not found
'file name for help/min/max etc
'get the fdes database name
lpDefault$ = ""
section$ = "General"
param$ = "detailsdbname"
'buffer for return value
value$ = Space$(128)
size% = Len(value$)
valid% = GetPrivateProfileString(section$, param$, lpDefault$, value$, size%, inifilename$)
If valid% = 0 Then Call inierrmessage: Exit Sub
detailsdbfilename$ = value$

'get the intl date and decimal chars
section$ = "intl"
param$ = "sShortDate"
sdatestring$ = WinGetString(section$, param$, sDefaultValue$)
 If UCase(Left$(sdatestring$, 1)) = "M" Then
  monthfirstindates% = True
 Else
  monthfirstindates% = False
 End If


section$ = "intl"
param$ = "SDate"
thedatesep$ = WinGetString(section$, param$, sDefaultValue$)
thedatesepasascii% = Asc(thedatesep$)

section$ = "intl"
param$ = "SDecimal"
thedecimalchar$ = WinGetString(section$, param$, sDefaultValue$)
thedecimalcharasascii% = Asc(thedecimalchar$)

Exit Sub


initerror:
Exit Sub

End Sub

Sub loadtogglesfromdbase (frm As Form, formname$, listtypeboxnames$(), mask As inputmask)
Dim db As database, tb As Table

For q% = 0 To UBound(listtypeboxnames$)
     controlname$ = listtypeboxnames$(q%)
     a$ = "loaduplistcontrol" + Trim$(Str$(q%))
     For i% = 0 To frm.Controls.Count - 1
         If frm.Controls(i%).Tag = a$ Then
          thiscontrolnumber% = i%
          Exit For
         End If
     Next i%

     GoSub rddbtogs
  
Next q%

Exit Sub

'*****************************
rddbtogs:
   
    
  'read in the toggle values to thismask.toggleval$

 Set db = OpenDatabase(detailsdbfilename$, False, True, "")
   
 Set tb = db.OpenTable(formname$)
 tb.Index = "ControlName"
 tb.Seek "=", controlname$
 If tb.NoMatch Then
    MsgBox "Control not found, problem with details data base", 32
    Exit Sub
 End If

'we are now on the correct record

 Call readtablestringfield(tb, "ToggleValues", valret$)
 mask.toggleval$ = valret$


tb.Close
db.Close


  

    'separate values by finding line feeds, always 0D(13),0A(10)
    'what if no return since single value only?-unlikely but possible!
    pos% = InStr(thismask.toggleval$, Chr$(13))
    If pos% = 0 Then
     frm.Controls(thiscontrolnumber%).AddItem thismask.toggleval$
    Else
      Do
        pos% = InStr(thismask.toggleval$, Chr$(13))
        If pos% > 0 Then
          frm.Controls(thiscontrolnumber%).AddItem Left$(thismask.toggleval$, pos% - 1)
          thismask.toggleval$ = Right$(thismask.toggleval$, Len(thismask.toggleval$) - pos% - 1)
        End If
      Loop Until pos% = 0
    End If
    If Len(thismask.toggleval$) > 0 Then
      frm.Controls(thiscontrolnumber%).AddItem thismask.toggleval$
    End If
    'set selected as default the first item
    frm.Controls(thiscontrolnumber%).ListIndex = 0

Return
'*****************************

End Sub

Sub Main ()
On Error GoTo what
Screen.MousePointer = 11
Call initialiseprogram


Screen.MousePointer = 0

Load Form1
'place the help emnu to far right
Form1.Helpmenu.Caption = Chr$(8) & Form1.Helpmenu.Caption
Form1.Show

Exit Sub


what:
e$ = Str$(Err)
If Err = 3024 Then
 MsgBox "DataBase files being updated by administrator, please try later"
 End
End If

MsgBox "Error in main" + e$
Resume Next

End Sub

Sub minmaxcheck (minmaxerr%, thisinput$, mask As inputmask)
 
 'auto called from lost_focus on text and combo boxes
 'to check min and max
 'value# = Val(thisinput$)
 'thisinput$ = Format$(thisinput$, "#########")
 tolerance# = .00000000000001
 If thisinput$ = "." Then
   thisinput$ = "0"
 End If
 thisinput$ = Format$(thisinput$, "General Number")
 value# = CDbl(thisinput$)
 minmaxerr% = False
 
 'If value# > mask.max# And Abs(mask.max# - 0) > .00000000001 Then
  If (value# - mask.max#) > tolerance# And Abs(mask.max#) > tolerance# Then
    minmaxerr% = True
    MsgBox "Input greater than maximum allowed of" + Str$(mask.max#), 16, "Input error"
    Exit Sub
 End If
 
 'If value# < mask.min# And Abs(mask.min# - 0) > .00000000001 Then
 If (mask.min# - value#) > tolerance# And Abs(value#) > tolerance# And mask.mandatory Then
    minmaxerr% = True
    MsgBox "Input less than minimum allowed of" + Str$(mask.min#), 16, "Input error"
    Exit Sub
 End If


End Sub

Sub numberonly (z%)
  
Rem check an entry box for numbers only and decimal point
  'Stop
  Select Case z%
   
   Case 8, 13, 45, thedecimalcharasascii%, 48 To 57
    'do nothing, ok!
   Case 13
    Beep
   Case Else
    MsgBox "Numbers and decimal point only", 48, "Incorrect input"
    z% = 0
  End Select
  
End Sub

Sub readtablefromdbase (formname$, mask As inputmask, controlname$)
 Dim db As database, tb As Table
 

    
    
 Set db = OpenDatabase(detailsdbfilename$, False, True, "")
   
 Set tb = db.OpenTable(formname$)
 tb.Index = "ControlName"
 tb.Seek "=", controlname$
 If tb.NoMatch Then
    MsgBox "Control not found, problem with details data base", 32
    tb.Close
    db.Close
    Exit Sub
 End If

'we are now on the correct record

mask.typeinchosen% = tb("Typeofinputchosen")
mask.length% = tb("LengthOfInput")
mask.decs% = tb("MaxNumberofDecimals")
mask.min# = tb("MinimumInputValue")
mask.max# = tb("MaximumInputValue")

bwzero% = tb("BlankWhenZero")
If bwzero% Then
  mask.bwzero% = 1
Else
  mask.bwzero% = 0
End If

DisplayOnly% = tb("DisplayOnly")
If DisplayOnly% Then
  mask.DisplayOnly% = 1
Else
  mask.DisplayOnly% = 0
End If

mandatory% = tb("Mandatory")
If mandatory% Then
  mask.mandatory% = 1
Else
  mask.mandatory% = 0
End If

Call readtablestringfield(tb, "HelpText", valret$)
mask.helptext$ = valret$

Call readtablestringfield(tb, "PromptText", valret$)
mask.prompttext$ = valret$

Call readtablestringfield(tb, "UserDefined1", valret$)
mask.udf1$ = valret$

Call readtablestringfield(tb, "UserDefined2", valret$)
mask.udf2$ = valret$

Call readtablestringfield(tb, "UserDefined3", valret$)
mask.udf3$ = valret$

Call readtablestringfield(tb, "UserDefined4", valret$)
mask.udf4$ = valret$

Call readtablestringfield(tb, "UserDefined5", valret$)
mask.udf5$ = valret$

tb.Close
db.Close



End Sub

Sub readtablestringfield (whichtable As Table, whichfield$, valret$)
 'need this since the database variable returned is a variant type and is null
 'and therefore generates error 94 if try to put in a string.
 
 If IsNull(whichtable(whichfield$)) Then
  valret$ = ""
 Else
  valret$ = whichtable(whichfield$)
 End If

End Sub

Sub setnontop (frm As Form)

'To reset the form XXXX to NON-TOPMOST, use the following code:

success% = SetWindowPos(frm.hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE)
     'success% <> 0 When Successful

End Sub

Sub settop (frm As Form)

'sets the form on top permanently

success% = SetWindowPos(frm.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE)
     'success% <> 0 When Successful

End Sub

Sub showcshelpscreen (callingfrm As Form)
  If Helpdis1.Visible = True Then
      Helpdis1.SetFocus
     'helpdis1.Visible = False
  Else
     Helpdis1.Visible = True
     'always want it on top
     'Call settop(Helpdis1)
     'callingfrm.SetFocus
  End If

End Sub

Sub showpromptandhelp (ct As Control, cap%)


'only use for boxes which have properties:
'   caption (cap% = True) Or text(cap% = False)
'note thismask is global
If cap% Then
  ct.Caption = thismask.prompttext
Else
  ct.Text = thismask.prompttext
End If

'also write the help text to the help form
'the help form is loaded at start up
'if the user presses shift+F1, it will be displayed
'need this because user could leave help displayed and
'then click on another box in the app
'the help screen would then be wrong
'this way it is always updated
Helpdis1.Text1.Text = thismask.helptext$

End Sub

Sub textlostfocuscheck (FrmResetFocusFlag%, box As Control)
'must do this here since user can move away with mouse
'so cannot check using keypress

'problem - if focus is reset following error as below (SetFocus)
'it then generates a lost focus again with index set at the box that
'had focus before the SetFocus. (Or could be combo or maskedit box previous)
'We do not want it through the error routine again!
If FrmResetFocusFlag% = True Then
  FrmResetFocusFlag% = False
  Exit Sub
End If


Select Case thismask.typeinchosen%
  Case 5 'numeric
   If thismask.bwzero% = 0 Then
      If box.Text = "" Then
        box.Text = "0"
      End If
   End If
   
   thisinput$ = box.Text
     If thisinput$ > "" Then
       Call minmaxcheck(minmaxerr%, thisinput$, thismask)
       If minmaxerr% Then
         box.SetFocus
         minmaxerr% = 0
         FrmResetFocusFlag% = True
       End If
     End If

  Case 6, 7, 8
   thisinput$ = box.Text
   If thisinput$ > "" Then
      Call basicdatecheck(bderr%, thisinput$, thismask)
      If bderr% Then
         box.SetFocus
         bderr% = 0
         FrmResetFocusFlag% = True
      End If
   End If
  Case Else
End Select

End Sub

Function WinGetString (sectionname$, sEntryName As String, ByVal sDefaultValue As String) As String


  'Retrieves Specific Entry from Win.Ini
    Dim sTemp As String * Max_EntryBuffer
    Dim nRetVal As Integer
    nRetVal = kpGetProfileString(sectionname$, sEntryName, sDefaultValue, sTemp, Len(sTemp))
    If nRetVal Then
      WinGetString = Left$(sTemp, nRetVal)
    End If

End Function

Sub YNonly (z%)
Rem check an entry box for YN only, also allow backspace del (8)
  Select Case z%
   Case 8, 89, 121, 78, 110
    'do nothing, ok!
   Case 13
    Beep
   Case Else
    MsgBox "Y or y, or N or n only", 48, "Incorrect input"
    z% = 0
  End Select
  

End Sub

