Declare Function agGetControlName$ Lib "ctrlname.dll" (ByVal hWnd%)
Global DbMultiLan As Database
Global DsMultiLan As Dynaset
Global LANGUAGE As Integer
Global sMultLangDatabasePath As String

Function GetCaption (Ds As Dynaset, LanguageCode As Integer) As String
  Select Case LanguageCode
    Case 0
       GetCaption = MLGetDynFld(Ds, "OriginalCaption")
    Case 1
       GetCaption = MLGetDynFld(Ds, "Language1Caption")
    Case 2
       GetCaption = MLGetDynFld(Ds, "Language2Caption")

    Case Else
        GetCaption = MLGetDynFld(Ds, "OriginalCaption")
 End Select

End Function

'*************************************************************************
'Purpose: Get Message Text from the Database.
'
'sAppName = Application Name (MAK File)
'nMsgNo - Message Number.
'nType - 1 will fetch message text
'        0 will fetch message title.
'nLanguage - 0 Defualt
'            1 First Language
'            2 Second Language
'**************************************************************************
Function GetMsgText (sAppName As String, nMsgNo As Integer, nType As Integer, nLanguage As Integer) As String






Static Flag As Integer
Static Db As Database
Static Tb As Table
 
    If Flag = 0 Then
       '***** Please modify following statement to suit your requirements.
       Set Db = OpenDatabase("D:\MULTLANG\MULTLANG.MDB")
       Set Tb = Db.OpenTable("MultiMessage")
        Tb.Index = "MultiMessage"
        Flag = 1
    End If

    Tb.Seek "=", sAppName, nMsgNo

    If Tb.NoMatch Then
        GetMsgText = ""
        Exit Function
    End If

    Select Case nLangauge

        Case 0
           If nType = 1 Then
              GetMsgText = Tb("OriginalMessage")
           Else
              GetMsgText = Tb("OriginalTitle")
           End If
           Exit Function
        Case 1
           If nType = 1 Then
              GetMsgText = Tb("Language1Message")
           Else
              GetMsgText = Tb("Language1Title")
           End If
           Exit Function

        Case 2
           If nType = 1 Then
              GetMsgText = Tb("Language2Message")
           Else
              GetMsgText = Tb("language2Title")
           End If
           Exit Function

        Case Else
           If nType = 1 Then
              GetMsgText = Tb("OriginalMessage")
           Else
              GetMsgText = Tb("OriginalTitle")
           End If
           Exit Function

    End Select

End Function

Function MLGetDynFld (Ds As Dynaset, Fld As String) As Variant
Dim FldData As Field

      Set FldData = Ds.Fields(Fld)  ' Set Field Properties

      If Not IsNull(Ds(Fld)) Then
         Select Case FldData.Type
           Case 10, 11, 12        ' String fields
             MLGetDynFld = Ds(Fld)
           Case 8                 ' Date field
             MLGetDynFld = Format$(Ds(Fld), "YYYYMMDD") ' Return Codebase style date
           Case Else              ' Numeric Data
             MLGetDynFld = TrimString(Str$(Ds(Fld)))
         End Select
      Else
         MLGetDynFld = ""
      End If




End Function

Function MLGetSnapFld (Ss As Snapshot, Fld As String) As Variant
Dim FldData As Field

      Set FldData = Ss.Fields(Fld)  ' Set Field Properties

      If Not IsNull(Ss(Fld)) Then
         Select Case FldData.Type
           Case 10, 11, 12        ' String fields
             MLGetSnapFld = Ss(Fld)
           Case 8                 ' Date field
             MLGetSnapFld = Format$(Ss(Fld), "YYYYMMDD") ' Return Codebase style date
           Case Else              ' Numeric Data
             MLGetSnapFld = TrimString(Str$(Ss(Fld)))
         End Select
      Else
         MLGetSnapFld = ""
      End If





End Function

Sub SetMLText (AppName As String, FormName As String, FormHandle As Form, LanguageCode As Integer, Ds As Dynaset)
'****************************************************************************
'Description : This function sets Captions of all the controls on the given Form
'              to current language of the user.
'Parameters  : AppName : Application Name (Mak file name)
'              FormName, Form Name Property as set through VB.Also must be set in
'              Tag Propery.
'              LanguageCode : 0 - Original Language
'                             1 - 1st Language ...
'              DS (Dynaset Handle )
'Returns:
'****************************************************************************
    Dim sFormName As String, sSeekCtrl As String, sComText As String
    Dim sCtrlText As String, I As Integer, sFormText As String
    Dim SearchString As String
    Dim sCtrlName As String     ' Control Name
    Dim sIndex As String

    sCtrlName = agGetControlName(FormHandle.hWnd)
    
    SearchString = "[AppName] = " + Chr$(34) + AppName + Chr$(34) + " And "
    SearchString = SearchString + "[FormName] = " + Chr$(34) + FormName + Chr$(34) + " And "
    'SearchString = SearchString + "[CtrlName] = " + Chr$(34) + FormHandle.Tag + Chr$(34)
    SearchString = SearchString + "[CtrlName] = " + Chr$(34) + sCtrlName + Chr$(34)
    
    '---- Search For AppName + FormName For Form Caption.
    Ds.FindFirst SearchString
    
    If Ds.NoMatch = False Then
        FormHandle.Caption = GetCaption(Ds, LanguageCode)
    End If


    '--- Set Captions for all controls on the given Form
    For I = 0 To FormHandle.Controls.Count - 1
        On Error Resume Next
        sCtrlName = agGetControlName(FormHandle.Controls(I).hWnd)
        If Err > 0 Then GoTo NextControl
        '--- Check if Control has index value set.
        sIndex = Trim$(Str$(FormHandle.Controls(I).Index))
        If Not Err Then
           sCtrlName = sCtrlName & "_" & sIndex
        End If
        
        On Error GoTo 0
        
        
        SearchString = "[AppName] = " + Chr$(34) + AppName + Chr$(34) + " And "
        SearchString = SearchString + "[FormName] = " + Chr$(34) + FormName + Chr$(34) + " And "
        SearchString = SearchString + "[CtrlName] = " + Chr$(34) + sCtrlName + Chr$(34)
        Ds.FindFirst SearchString
        
        If Ds.NoMatch = False Then
          sCtrlText = GetCaption(Ds, LanguageCode)
                On Error Resume Next
                '---- Do not bother about the controls which do not have
                '---- Caption property.
                FormHandle.Controls(I).Caption = sCtrlText
                On Error GoTo 0
            
         End If
NextControl:
   Next I
End Sub

Function TrimString (InputStr As String) As String

  TrimString = LTrim$(RTrim$(InputStr))

End Function

