Register:Start
  New (Contact:Con)
  Jorf:File("Register.Jrf",Here)
  Con=Struct:Find('Contact','FullName',Null)
  If (Con==Null)
    Con->Type = "JORFWIN"
    Con->Location = "USA"

  Event:Add()
  Win:Add ("JORF Registration",5,10)
    Group:"Send to:" Row:1 Col:1 Len:6 Wid:40
    Input:"&Name   ", Wid:30, Field:"Con->FullName"
    Input:"Company",  Wid:30, Field:"Con->Company"
    Input:"&Address", Wid:30, Field:"Con->Addr1"
    Input:"       ",  Wid:30, Field:"Con->Addr2"
    Input:"       ",  Wid:30, Field:"Con->Addr3"
    Radio:"&USA"  Row:7 Col:2
      Action:"Con->Location='USA'"
      UnAction:"Con->Location=Null"
      Check:"Con->Location=='USA'"
      After:"Register:Calc(Con)"
    Radio:"&Canada/Mexico" Row:7 Col:11
      Action:"Con->Location='CanMex'"
      UnAction:"Con->Location=Null"
      Check:"Con->Location= ='CanMex'"
      After:"Register:Calc(Con)"
    Radio:"&Foreign" Row:7 Col:30
      Action:"Con->Location='Foreign'"
      UnAction:"Con->Location=Null"
      Check:"Con->Location=='Foreign'"
      After:"Register:Calc(Con)"
    String:"Press TAB between fields" Row:8 Col:10

    Group:"Registration for"
      Row:9  Col:1  Len:9  Wid:60
    Radio:" &JORF PC Version"
      Check:"Con->Type=='JPC'"
      Action:"Con->Type='JPC'"
      UnAction:"Con->Type= Null"
      After:"Register:Calc(Con)"
    String:"       Includes 250 page manual, quick reference card"
    String:"       support, notice of upgrades, good karma."
    Radio:" &DOS386/Win Version"
      Check:"Con->Type=='JORFWIN'"
      Action:"Con->Type='JORFWIN'"
      UnAction:"Con->Type= Null"
      After:"Register:Calc(Con)"
    String:"       Includes all the above plus JORF386 (uses high"
    String:"       memory to run faster) and MS Windows interpreters"
    Radio:" JORF Developers &Kit"
      Check:"Con->Type=='JDK'"
      Action:"Con->Type='JDK'"
      UnAction:"Con->Type= Null"
      After:"Register:Calc(Con)"
    String:"       Includes all the above, plus 100 page Developer's"
    String:"       guide, link libraries,  sample PRJ and batch files"
    String:"Press SPACE BAR to select a button" Row:19 Col:13

    Group:"Amount" Row:1 Col:43 Len:6 Wid:18
      Display:"Register:Calc(Con)"

    Button:"&Print"   Row:20 Col:5  Wid:20 Action:"Register:Print(Con)"
    Button:"E&xit"    Row:20 Col:35 Wid:20 Action:"Return Null"
  Jorf:Write(Con)
  Return(Ok)

Register:Calc(Con)
  Switch (Con->Type)
    Case "JPC"
      Move:To(3,45)
      Str:Put("JORF PC   "+Num:Str(45,"##0.00"))
      Con->Total = 45
    Case "JDK"
      Move:To(3,45)
      Str:Put("JDK       "+Num:Str(170,"##0.00"))
      Con->Total = 170
    Else "JORFWIN"
      Move:To(3,45)
      Str:Put("JORF/WIN  "+Num:Str(85,"##0.00"))
      Con->Total = 85

  Switch (Con->Location)
    Case "Foreign"
      Move:To(4,45)
      Str:Put("Shipping  "+Num:Str(10,"##0.00"))
      Con->Total = Con->Total + 10
    Else
      Move:To(4,45)
      Str:Put("Shipping  "+"  FREE")

  Move:To(5,45)
  Str:Put("        --------")
  Move:To(6,45)
  Str:Put("Total     "+Num:Str(Con->Total,"##0.00"))
  Return (Ok)

Register:Print(Con)
  New (Dest,Date)
  Dest=Jorf:Printer()
  If (Dest)
    Date = Date:Str(Date:Get,"s d, yyyy")

    Rep:Add ("JORF Registration Form", 5, 5, 60, 75, Here)
      Item:"Date"                 NewRow:4
      Item:"'To: Wayland Bruns'"  NewRow:2
      Item:"'The JORF Company'"   NewRow:1
      Item:"'25858 Elwood Road'"  NewRow:1
      Item:"'Colton, OR 97017'"   NewRow:1
      Item:""                     NewRow:1
      Item:"'Wayland:'"           NewRow:1
      Item:""                     NewRow:1
      Item:"'I would like to register my copy of JORF.  I have enclosed'"
        NewRow:1
      Item:"'a check in the amount of $'+Str:Aft(Num:Str(Con->Total,'##0.00'),' ')+' for a:'"
        NewRow:1
      Item:""
        NewRow:1
      Item:"'     A JORF DOS Interpreter.     '"  Before:"Con->type=='JPC'"
        NewRow:1
      Item:"'     A JORF DOS-386/Windows Interpreter.'"  Before:"Con->type=='JORFWIN'"
        NewRow:1
      Item:"'     A JORF Developers Kit.         '"  Before:"Con->type=='JDK'"
        NewRow:1
      Item:""
        NewRow:1
      Item:"'Please send the package to:'"      NewRow:1
      Item:""                                   NewRow:1
      Item:"'       '+Con->FullName"            NewRow:1
      Item:"'       '+Con->Company "            NewRow:1
      Item:"'       '+Con->Addr1   "            NewRow:1
      Item:"'       '+Con->Addr2   "            NewRow:1
      Item:"'       '+Con->Addr3   "            NewRow:1
      Item:""                                   NewRow:1
      Item:"'Thank You'"                        NewRow:1
      Next:"Null"
    File:Print("Jreport.lst",Dest)
  Return (Ok)

Class:Contact           | Class definition for a Contact structure
  Index:FullName        | Full name
  Index:Company         | Company
  Index:WorkPhone       | Work Phone
  Index:LastName        | Last Name
  Index:ZipCode         | Zip Code
  Addr1                 | Address
  Addr2
  Addr3
  Location
  HomePhone             | Home Phone
  WorkPhone
  FaxPhone
  Birthday
  Anniversary
  Dear
  Comment
  Notes                 | Notepad
  Type
  Total

