program SpDemo;

{This is an enhanced version of Splash by Lou Grinzo as published in
the May 1994 issue of Windows Tech Journal, pp 46-50.}

{The enhancements include a more rehible delay method. - the origional
caused GPF's on my system.  The icons for the animated dialog were changed
to show a spinning clock, globe, slot, or meter.  Three normal dialogs were
also created to show the clock, globe, slot or meter.}

{The demo program uses the ObjectMate 2.6 shareware libary available in
the Borland Pascal Forum Windows Tools Library on Compuserve to center windows on
the screen and to provide the special effects dialogs and flush buttons.}

uses
   OWindows, ODialogs, OMemory, WinTypes, WinProcs, SFX200,
   ToolHelp, Strings, WinDOS, Splash;

{$R SPLASH.RES}
{$M 18092, 18092}

const
   AppName = 'Splash - Animation Panel Demo Program';
   {Splash panel id's and constants}
   dlg_id     =  101; {142x92}
   dlg2_id    =  100; {89x92}
   dlg3_id    =  102; {Globe}
   dlg4_id    =  103; {clock}
   dlg5_id    =  105; {slot}
   dlg6_id    =  106; {meter}
   dlg7_id    =  107; {142x89}
   bmp1_id    =  100; {Make a splash 5 sec}
   bmp2_id    =  101; {Initialization}
   bmp3_id    =  102; {Caveman}
   bmp4_id    =  103; {Make a splash}
   bmp5_id    =  104; {blank gray}
   dlg_sec    =   10; {dialog timeout}
   start_icon =  300; {globe... 100..113} {slot... 200..220}
   end_icon   =  323; {clock... 300..310} {eyes... 400..411}
   icon_x     =  126; {x-position of icon}
   icon_y     =  135; {y=position of icon}
   icon_msec  =  200; {period between icon changes}
   {About Dialog id's}
   ab_WinMode = 101;
   ab_FreeMem = 102;
   ab_ResPct  = 103;
   ab_mathco  = 104;
   ab_winver  = 105;
   ab_dosver  = 106;
   ab_register= 24;
   ab_credits = 25;
   dlg_About = 'ABOUT';
   dlg_Register = 'REGISTER';
   dlg_Credit = 'CREDITS';

type
   TDemoApp = object(TApplication)
      procedure InitMainWindow; virtual;
   end;

  { Register Dialog Declarations }
  PRegisterDlg = ^TRegisterDlg;
  TRegisterDlg = object (TDialog)
     constructor Init (AParent: PWindowsObject; AnID: PChar);
     procedure   GetWindowClass (var WC: TWndClass); virtual;
     function    GetClassName: PChar; virtual;
     procedure   SetupWindow; virtual;
  end;

  { Memory About Dialog Declarations }
  PAbtDlg = ^TAbtDlg;
  TAbtDlg = object (TDialog)
     constructor Init (AParent: PWindowsObject; AnID: PChar);
     procedure   GetWindowClass (var WC: TWndClass); virtual;
     function    GetClassName: PChar; virtual;
     procedure   SetupWindow; virtual;
     procedure   IDRegister (var Msg: TMessage); virtual id_First + ab_register;
     procedure   IDCredits (var Msg: TMessage); virtual id_First + ab_credits;
  end;

   {Credits Dialog}
   PCreditsDlg = ^TCreditsDlg;
   TCreditsDlg = object(TDialog)
      constructor Init(AParent: PWindowsObject; AnID: PChar);
      procedure SetupWindow; virtual;
   end;

   {Main Window}
   PDemoWindow = ^TDemoWindow;
   TDemoWindow = object(TSFXWindow)
      constructor Init(AParent: PWindowsObject; AName: PChar);
      procedure SetUpWindow; virtual;
      function CanClose: boolean; virtual;
      procedure WMCommand (var Msg: TMessage); virtual wm_First + wm_Command;
   end;

{ ------------------------------------ }

function LongToStr(Destination: PChar; L: LongInt): PChar;
{-Convert an integer to a null terminated string}
var
   Strng : string;
begin
   Str(L, Strng);
   LongToStr := StrPCopy(Destination, Strng);
end;

{ ------------------------------------ }

procedure TDemoApp.InitMainWindow;
begin
   MainWindow := New(PDemoWindow,Init(nil,AppName));
end;


{ ************ TAbtDlg ************ }
constructor TAbtDlg.Init;
begin
  inherited Init(APArent,AnID);
  { - set SFX dialog to steel attribute }
   Attr.Param := mws_Flat3DSteel;
end;

procedure TAbtDlg.GetWindowClass(var WC: TWndClass);
begin
  inherited GetWindowClass(WC);
end;

function TAbtDlg.GetClassName: PChar;
begin
  GetClassName := 'BORDLG_ABT';
end;

procedure TAbtDlg.SetupWindow;
var
  M           : TMemManInfo;
  H           : TSysHeapInfo;
  Temp        : array[0..40] of Char;
  PercentFree : Word;
  UserFree    : Word;
  len         : Word;
  Ver: Longint;
  ArgList: array[0..1] of word;
  WindowsVersion: Array[0..30] of Char;
  VersionDos: Array[0..30] of Char;
begin {SetupWindow}
  inherited SetupWindow;
  {Center the main window on the screen}
   CenterWindow (0, HWindow);
  if (GetWinFlags and wf_Enhanced) <> 0 then
    SendDlgItemMsg (ab_WinMode, wm_SetText, 0,
      LongInt (PChar('386 Enhanced Mode')))
  else
    SendDlgItemMsg (ab_WinMode, wm_SetText, 0,
      LongInt (PChar ('Standard Mode')));

  if WordBool(GetWinFlags and WF_80x87) then
    SendDlgItemMsg (ab_MathCo, wm_SetText, 0,
      LongInt (PChar('Present')))
  else
    SendDlgItemMsg (ab_MathCo, wm_SetText, 0,
      LongInt (PChar('None')));

    LongToStr (Temp, GetFreeSpace(0) div 1024); {K}
   {insert a comma}
    len := StrLen (temp);
    if len > 3 then
    begin
       Move(temp[len-3], temp[len-2], 5);
       temp[len-3] := ',';
    end;
  StrCat (Temp,' K bytes');
  SendDlgItemMSg (ab_FreeMem, wm_SetText, 0, LongInt(@TEMP));
  H.dwSize := SizeOf (TSysHeapInfo);
  SystemHeapInfo (@H);
  if H.wUserFreePercent < H.wGDIFreePercent then
    PercentFree := H.wUserFreePercent
  else
    PercentFree := H.wGDIFreePercent;
  Str (PercentFree,Temp);
  StrCat (Temp,' % free');
  SendDlgItemMsg (ab_ResPct, wm_SetText, 0, LongInt(@TEMP));

  Ver := GetVersion;
  ArgList[0] := Lo(LoWord(Ver));
  ArgList[1] := Hi(LoWord(Ver));
  wvSprintf(WindowsVersion, '%d.%d', ArgList);
  SendDlgItemMsg (ab_WinVer, wm_SetText, 0, LongInt(@WindowsVersion));

  Ver := DosVersion;
  ArgList[0] := Lo(Ver);
  ArgList[1] := Hi(Ver);
  wvsprintf(VersionDos, '%d.%d', ArgList);
  SendDlgItemMsg (ab_DOSVer, wm_SetText, 0, LongInt(@VersionDos));
end; {SetupWindow}


{ TRegisterdlg's Methods }
constructor TRegisterDlg.Init;
begin {Init}
  inherited Init (AParent,AnID);
  {Set SFX dialog to steel attribute}
   Attr.Param := mws_Flat3DSteel;
end; {Init}

procedure TRegisterDlg.GetWindowClass(var WC: TWndClass);
begin {GetWindowClass}
  inherited GetWindowClass (WC);
end;  {GetWindowClass}

function TRegisterDlg.GetClassName: PChar;
begin {GetClassName}
  GetClassName := 'Register';
end; {GetClassName}


procedure TRegisterDlg.SetupWindow;
begin
 inherited SetupWindow;
  {Center the main window on the screen}
   CenterWindow (0, HWindow);
end;

procedure TAbtDlg.IDRegister (var Msg: TMessage);
begin
  Application^.ExecDialog (New (PRegisterDlg, Init (@Self, PChar (dlg_Register))));
end;

 procedure TAbtDlg.IDCredits (var Msg: TMessage);
begin
  Application^.ExecDialog (New (PCreditsDlg, Init (@Self, PChar (dlg_Credit))));
end;

{ ************ TCreditsDlg ************ }
constructor TCreditsDlg.Init;
begin
  inherited Init(APArent,AnID);
  { - set SFX dialog to steel attribute }
   Attr.Param := mws_Flat3DSteel;
end;

procedure TCreditsDlg.SetupWindow;
var
  M: TMemManInfo;
  H: TSysHeapInfo;
  Temp: array[0..40] of Char;
  PercentFree,UserFree: Word;
  len: Word;
begin
  inherited SetupWindow;
  { - added to center the main window on the screen }
   CenterWindow(0, HWindow);
end;

{ ************ TDemoWindow ************ }
constructor TDemoWindow.Init(AParent: PWindowsObject; AName: PChar);
var
  AControl: PSFXButton;
begin
   TSFXWindow.Init(AParent, AName);
   Attr.Menu := LoadMenu(HInstance, 'SPDEMO');
   Attr.W := 600;
   Attr.H := 440;
   {Attr.Style := Attr.Style or mws_FlatClient;}
   {Attr.Style := Attr.Style or mws_FramedClient;}
   {Attr.Style := Attr.Style or mws_RaisedClient;}
   {Attr.Style := Attr.Style or mws_Glaze;}
   {Attr.Style := Attr.Style or mws_Steel;}
   {Attr.Style := Attr.Style or mws_SFXFrame;}
   {Attr.Style := Attr.Style or mws_3DFrame;}
   {Attr.Style := Attr.Style or mws_3DGlaze;}
   {Attr.Style := Attr.Style or mws_3DSteel;}
   {Attr.Style := Attr.Style or mws_Flat3DFrame;}
   {Attr.Style := Attr.Style or mws_Flat3DGlaze;}
   {Attr.Style := Attr.Style or mws_Flat3DSteel;}
   {Attr.Style := Attr.Style or mws_Framed3DFrame;}
   {Attr.Style := Attr.Style or mws_Framed3DGlaze;}
   {Attr.Style := Attr.Style or mws_Framed3DSteel;}
   {Attr.Style := Attr.Style or mws_Raised3DFrame;}
   {Attr.Style := Attr.Style or mws_Raised3DGlaze;}
   Attr.Style := Attr.Style or  mws_Raised3DSteel;
   AControl := New(PSFXButton, Init(@Self, 1, '', 500, 330, 100, 40));
   AControl^.Attr.Style := AControl^.Attr.Style or mbs_flush
end;

procedure TDemoWindow.SetUpWindow;
begin
   TSFXWindow.SetUpWindow;
   { -added to center the splash window on the screen }
   CenterWindow(0, HWindow);
   Attr.Menu := LoadMenu(HInstance, 'SPDEMO');
end;

function TDemoWindow.CanClose: boolean;
begin
   { -Closing timed, animated splash over parent }
   DoAniSplash(dlg2_id,bmp4_id,dlg_sec,icon_x,icon_y,
      start_icon,end_icon,icon_msec);
   CanClose := TSFXWindow.CanClose;
end;

procedure TDemowindow.WMCommand (var Msg: TMessage);
begin
   case Msg.Wparam of
 1,101  : Closewindow;
   201  : DoAniSplash(103,104,60,50,50,300,323,100); {Clock}
   202  : DoAniSplash(105,104,60,50,50,400,411,150); {Eyes}
   203  : DoAniSplash(102,104,60,50,50,100,113,150); {Globe}
   204  : DoAniSplash(104,104,60,50,50,200,221,250); {Slot}
   205  : DoAniSplash(106,104,60,50,50,500,512,150); {Meter}
   301  : Application^.ExecDialog(New(PAbtDlg, Init(@Self, 'About')));
   else
		TSFXWindow.WMCommand(Msg);
   end; {case}
end;

{ ------------------------------------ }

{ -added to delay without message processing }
procedure Delay(T: LongInt);
{T is time in ms}
var Start: LongInt;
begin
   Start := GetTickcount;
   while GetTickCount - Start <= T do begin
   end;
end;

{ ------------------------------------ }

var
   MyApp: TDemoApp;

begin

   MyApp.Init(AppName);

   { Timed opening splash - enter or left button cancels }
   DoSplash(dlg2_id,bmp3_id,dlg_sec);

   { Modeless splash - initialization }
   StartModelessSplash(dlg2_id,bmp2_id);
   { Waste some time with made work... }
   Delay(2000);
   { End the modeless splash dialog }
   EndModelessSplash;

   MyApp.Run;

   { See CanClose for additional closing dialog info}
   { Closing timed splash not on parent - enter or left button cancels }
   DoSplash(dlg7_id,299,4);

   MyApp.Done;
end.
